#include <wx/wx.h>

#include "FGIObject.h"

FGIObject::FGIObject(wxInt32 model, wxDouble lon, wxDouble lat, wxDouble alt, wxDouble head)
{
    ModelId   = model;
    Longitude = lon;
    Latitude  = lat;
    Altitude  = alt;
    Heading   = head;
}

void FGIObject::SetAlt(wxDouble alt)
{
    Altitude = alt;
}

wxDouble FGIObject::GetLon()
{
    return Longitude;
}

wxDouble FGIObject::GetLat()
{
    return Latitude;
}

wxInt32 FGIObject::GetModelId()
{
    return ModelId;
}

wxString FGIObject::GetDef(wxString modelname, bool static_mod)
{
    if (static_mod)
        return wxT("OBJECT_STATIC ") + modelname + wxString::Format(wxT(" %lf %lf %lf %lf"), Longitude, Latitude, Altitude, Heading);
    else
        return wxT("OBJECT_SHARED ") + modelname + wxString::Format(wxT(" %lf %lf %lf %lf"), Longitude, Latitude, Altitude, Heading);
}

