#ifndef FGI_TILE_H
#define FGI_TILE_H

#include <wx/wx.h>
#include <wx/dynarray.h>

#include "FGIObject.h"

WX_DECLARE_OBJARRAY(FGIObject, FGIObjectArray);

class FGITile
{
private:
    static const wxDouble Epsilon = 0.0000001;

    static wxDouble BucketSpan(wxDouble lat);
    static wxString FormatLon(wxDouble lon);
    static wxString FormatLat(wxDouble lat);

    wxString        Name;
    wxString        Path;

public:
    FGITile(wxString name, wxString path);

    static wxString GetNameFromDeg(wxDouble lon, wxDouble lat);
    static wxString GetPathFromDeg(wxDouble lon, wxDouble lat);

    wxString        GetName();
    wxString        GetPath();

    FGIObjectArray  Objects;
};

#endif

